'''*****************************************
* Large Assignment 1: L-Systems
* Name: Liz Courts
* E-mail: lizcourts97@unm.edu
* Course: CS491, Computational Fabrication
* Submitted: 2023-09-14
*
* A program that uses L-systems to model three
* plants:
* - tomato (slice)
* - basil
* - rosemary
***********************************************'''

add_library('Turtle')

sys.path.append(os.path.abspath('../libraries/turtlePython'))
import turtlePython as tp
import datetime as dt

t = Turtle(this)
 
def setup():
    size(900, 900)
    background(255)
    frameRate(10)
    fill(255)
    stroke(0, 0, 0)
    strokeJoin(ROUND)
    t.penUp()
    t.goToPoint(width / 2, height - 10)
    t.penDown()
    noLoop()
    
def draw():
    
    #rosemary(1, 10, 15)
    #basil_leaf(l = random(5, 20))
    t.penUp()
    t.goToPoint(width / 2, height / 2)
    t.penDown()
    tomato()
        
def r_angle(x = 'F'):
    r = ['-', '+']
    r.extend((floor(len(x) / 2)+1)*('X'))
    result = ''
    for i in x:
        result += tp.random.choice(r) + i
    result = result.replace('X', '')
    return result

def tomato():
    t.right(random(-90, 90))
    t.penUp()
    t.goToPoint(random(width * 0.1, width * 0.9), random(height * 0.2, height * 0.9))
    t.penDown()
    lsys = tp.LSysCCurve('F')
    lsys.iteration(floor(random(5, 12)))
    lsys.draw(t, lsys.computed_word, 3, 45, random(0.5, 2.0), False)

def basil_leaf(l = 10, a = 50, s = 1.0, v = 6):
    lsys = tp.LSystem('F')
    lsys.rules['F'] = ['F']
    strokeWeight(l)
    strokeJoin(MITER)
    strokeCap(SQUARE)
    
    # decrease length of main vascular branches
    v = floor(random(3, 8))
    while v >= 1:
        new_rule = '![-F][+F]'
        new_rule = new_rule.replace('F', v * ('F'))
        lsys.rules['F'][0] += new_rule + 'FF!F'
        v -= 1

    lsys.rules['A'] = ['F']
    lsys.iteration(1)
    lsys.computed_word += 'F'
    lsys.draw(t, lsys.computed_word, l, a, 1.0, False)
    strokeWeight(1)
    
def rosemary(i = 1, l = 10, a = 15, s = 1.0):
    lsys = tp.LSystem('FFFFFFFF')
    leaf = 'HHHHHH'
    
    lsys.rules['F'] = ['F[-HH[--' + leaf + '][-' + leaf + ']][+HH[++' + leaf + '][+' + leaf + ']]' + 'HHHF']
    
    lsys.iteration(i)
    strokeWeight(l / 1.5)
    lsys.draw(t, lsys.computed_word, l, a, s, True)
    lsys.axiom = 'FFF'
    lsys.computed_word = lsys.axiom
    lsys.rules['F'] = ['F[-' + leaf + '][+' + leaf + ']' + 'HHHHHH']
    lsys.iteration(i)
    strokeWeight(l / 2)
    lsys.draw(t, lsys.computed_word, l, a, s, True)
    
def keyPressed():
    s = dt.datetime.now().strftime('%Y%m%d-%H%M%S')
    if key==' ':
        filename = s + '.png'
        save(filename)
        print('saved file: ' + filename)
    else:
        pass
        
def mouseClicked():
    t.clearTurtleHistory()
    redraw()
